MM = LibStub("AceAddon-3.0"):NewAddon("MikaMounter","AceConsole-3.0","AceEvent-3.0");
local AceLocale = LibStub("AceLocale-3.0");
local L = AceLocale:GetLocale("MikaMounter");

BINDING_HEADER_MIKA_MOUNTER = "Mika Mounter";
BINDING_NAME_MOUNT_AUTO = L["Flying or ground mount"];
BINDING_NAME_MOUNT_GROUND = L["Ground mount"];

walkRidingMounts = {
	30174, -- Riding Turtle
}
qirajRidingMounts = {
	25953, -- Blue Qiraji Battle Tank
	26053, -- Red Qiraji Battle Tank
	26055, -- Yellow Qiraji Battle Tank
	26056, -- Green Qiraji Battle Tank
	26656, -- Black Qiraji Battle Tank
}
slowRidingMounts = {
	458, -- Brown Horse
	470, -- Black Stallion
	472, -- Pinto
	580, -- Timber Wolf
	5784, -- Summon Felsteed
	6648, -- Chestnut Mare
	6653, -- Dire Wolf
	6654, -- Brown Wolf
	6777, -- Gray Ram
	6898, -- White Ram
	6899, -- Brown Ram
	8394, -- Striped Frostsaber
	8395, -- Emerald Raptor
	10789, -- Spotted Frostsaber
	10793, -- Striped Nightsaber
	10796, -- Turquoise Raptor
	10799, -- Violet Raptor
	10873, -- Red Mechanostrider
	10969, -- Blue Mechanostrider
	13769, -- Summon Warhorse (Alliance)
	17453, -- Green Mechanostrider
	17454, -- Unpainted Mechanostrider
	17462, -- Red Skeletal Horse
	17463, -- Blue Skeletal Horse
	17464, -- Brown Skeletal Horse
	18989, -- Gray Kodo
	18990, -- Brown Kodo
	34406, -- Brown Elekk
	34769, -- Summon Warhorse (Horde)
	34795, -- Red Hawkstrider
	35018, -- Purple Hawkstrider
	35020, -- Blue Hawkstrider
	35022, -- Black Hawkstrider
	35710, -- Gray Elekk
	35711, -- Purple Elekk
	42776, -- Spectral Tiger
	43899, -- Brewfest Ram
	48025, -- Headless Horsemans Mount
	58983, -- Big Blizzard Bear
	64657, -- White Kodo
	64658, -- Black Wolf
	64977, -- Black Skeletal Horse
}
fastRidingMounts = {
	15779, -- White Mechanostrider Mod B
	16055, -- Black Nightsaber
	16056, -- Ancient Frostsaber
	16080, -- Red Wolf
	16081, -- Winter Wolf
	16082, -- Palomino
	16083, -- White Stallion
	16084, -- Mottled Red Raptor
	17229, -- Winterspring Frostsaber
	17450, -- Ivory Raptor
	17458, -- Fluorescent Green Mechanostrider
	17459, -- Icy Blue Mechanostrider Mod A
	17460, -- Frost Ram
	17461, -- Black Ram
	17465, -- Green Skeletal Warhorse
	17481, -- Rivendare's Deathcharger
	18922, -- Teal Kodo
	18991, -- Green Kodo
	22717, -- Black War Steed
	22718, -- Black War Kodo
	22719, -- Black Battlestrider
	22720, -- Black War Ram
	22721, -- Black War Raptor
	22722, -- Red Skeletal Warhorse
	22723, -- Black War Tiger
	22724, -- Black War Wolf
	23161, -- Summon Dreadsteed
	23214, -- Summon Charger (Alliance)
	23219, -- Swift Mistsaber
	23221, -- Swift Frostsaber
	23222, -- Swift Yellow Mechanostrider
	23223, -- Swift White Mechanostrider
	23225, -- Swift Green Mechanostrider
	23227, -- Swift Palomino
	23228, -- Swift White Steed
	23229, -- Swift Brown Steed
	23238, -- Swift Brown Ram
	23239, -- Swift Gray Ram
	23240, -- Swift White Ram
	23241, -- Swift Blue Raptor
	23242, -- Swift Olive Raptor
	23243, -- Swift Orange Raptor
	23246, -- Purple Skeletal Warhorse
	23247, -- Great White Kodo
	23248, -- Great Grey Kodo
	23249, -- Great Brown Kodo
	23250, -- Swift Brown Wolf
	23251, -- Swift Timber Wolf
	23252, -- Swift Gray Wolf
	23338, -- Swift Stormsaber
	23509, -- Frostwolf Howler
	23510, -- Stormpike Battle Charger
	24242, -- Swift Razzashi Raptor
	24252, -- Swift Zulian Tiger
	26656, -- Black Qiraji Battle Tank
	33660, -- Swift Pink Hawkstrider
	34767, -- Summon Charger (Horde)
	34790, -- Dark War Talbuk
	34896, -- Cobalt War Talbuk
	34897, -- White War Talbuk
	34898, -- Silver War Talbuk
	34899, -- Tan War Talbuk
	35025, -- Swift Green Hawkstrider
	35027, -- Swift Purple Hawkstrider
	35028, -- Swift Warstrider
	35712, -- Great Green Elekk
	35713, -- Great Blue Elekk
	35714, -- Great Purple Elekk
	36702, -- Fiery Warhorse
	39315, -- Cobalt Riding Talbuk
	39316, -- Dark Riding Talbuk
	39317, -- Silver Riding Talbuk
	39318, -- Tan Riding Talbuk
	39319, -- White Riding Talbuk
	41252, -- Raven Lord
	42777, -- Swift Spectral Tiger
	43688, -- Amani War Bear
	43900, -- Swift Brewfest Ram
	46628, -- Swift White Hawkstrider
	48025, -- Headless Horsemans Mount
	48027, -- Black War Elekk
	48778, -- Acherus Deathcharger
	49322, -- Swift Zhevra
	49378, -- Brewfest Riding Kodo
	49379, -- Great Brewfest Kodo
	50869, -- Brewfest Kodo
	51412, -- Big Battle Bear
	54753, -- White Polar Bear Mount
	55531, -- Mechano-Hog
	58983, -- Big Blizzard Bear
	59785, -- Black War Mammoth (Alliance)
	59788, -- Black War Mammoth (Horde)
	59791, -- Wooly Mammoth (Alliance)
	59793, -- Wooly Mammoth (Horde)
	59797, -- Ice Mammoth (Horde)
	59799, -- Ice Mammoth (Alliance)
	60114, -- Armored Brown Bear (Alliance)
	60116, -- Armored Brown Bear (Horde)
	60118, -- Black War Bear (Alliance)
	60119, -- Black War Bear (Horde)
	60424, -- Mekgineer's Chopper
	61425, -- Traveler's Tundra Mammoth (Alliance)
	61447, -- Traveler's Tundra Mammoth (Horde)
	61469, -- Grand Ice Mammoth (Horde)
	61470, -- Grand Ice Mammoth (Alliance)
	63232, -- Swift Elwynn Steed
	63635, -- Swift Darkspear Raptor
	63636, -- Swift Ironforge Ram
	63637, -- Swift Darnassian Mistsaber
	63638, -- Turbostrider
	63639, -- Great Azuremyst Elekk
	63640, -- Swift Orgrimmar Wolf
	63641, -- Great Mulgore Kodo
	63642, -- Swift Silvermoon Hawkstrider
	63643, -- Swift Forsaken Warhorse
	65639, -- Swift Red Hawkstrider
	65641, -- Great Golden Kodo
	65644, -- Swift Purple Raptor
	65645, -- White Skeletal Warhorse
	65646, -- Swift Burgundy Wolf
}
slowFlyingMounts = {
	32235, -- Golden Gryphon
	32239, -- Ebon Gryphon
	32240, -- Snowy Gryphon
	32243, -- Tawny Wind Rider
	32244, -- Blue Wind Rider
	32245, -- Green Wind Rider
	44153, -- Flying Machine
	46197, -- X-51 Nether-Rocket
	48025, -- Headless Horsemans Mount
	61451, -- Flying Carpet
}
fastFlyingMounts = {
	32242, -- Swift Blue Gryphon
	32246, -- Swift Red Wind Rider
	32289, -- Swift Red Gryphon
	32290, -- Swift Green Gryphon
	32292, -- Swift Purple Gryphon
	32295, -- Swift Green Wind Rider
	32296, -- Swift Yellow Wind Rider
	32297, -- Swift Purple Wind Rider
	37015, -- Swift Nether Drake
	39798, -- Green Nether Ray
	39800, -- Red Nether Ray
	39801, -- Purple Nether Ray
	39802, -- Silver Nether Ray
	39803, -- Blue Nether Ray
	40192, -- Ashes of Al'ar
	41513, -- Onyx Nether Drake
	41514, -- Azure Nether Drake
	41515, -- Cobalt Nether Drake
	41516, -- Purple Nether Drake
	41517, -- Veridian Nether Drake
	41518, -- Violet Nether Drake
	43810, -- Frost Wyrm
	43927, -- Cenarion War Hippogryph
	44151, -- Turbo-Charged Flying Machine
	44744, -- Merciless Nether Drake
	46199, -- X-51 Nether-Rocket X-TREME
	48025, -- Headless Horsemans Mount
	49193, -- Vengeful Nether Drake
	51960, -- Frostwyrm
	54729, -- Winged Steed of the Ebon Blade
	58615, -- Brutal Nether Drake
	59567, -- Azure Drake (Maly 25)
	59568, -- Blue Drake (Maly 10)
	59569, -- Bronze Drake
	59570, -- Red Drake (Wyrmrest Accord)
	59571, -- Twilight Drake (Sartharion hard mode 25-man)
	59650, -- Black Drake (Sartharion hard mode 10-man)
	59961, -- Red Proto-Drake (Glory of the Hero)
	59976, -- Black Proto-Drake (Glory of the Heroic Raider)
	59996, -- Blue Proto-Drake
	60002, -- Time-Lost Proto-Drake
	60021, -- Plagued Proto-Drake (Glory of the Raider)
	60024, -- Violet Proto-Drake (What A Strange Trip It Has Been)
	60025, -- Albino Drake
	61229, -- Armored Snowy Gryphon
	61230, -- Armored Blue Wind Rider
	61294, -- Green Proto-Drake
	61309, -- Magnificent Flying Carpet
	62042, -- Black Dragonhawk
	63796, -- Mimiron's Head
	63844, -- Argent Hippogryph
	63956, -- Ironbound Proto-Drake (Heroic Ulduar Raider)
	63963, -- Rusted Proto-Drake (Ulduar Raider)
	64927, -- Deadly Gladiator's Frostwyrm
}

waterMounts = {
	64731, -- Sea Turtle
}

MM.options = {
	name = "MikaMounter",
	type = "group",
	handler = MM,
	args = {
		mount = {
			type = "execute",
			name = "Mount random mount",
			desc = L["Mount random mount depending on your location"],
			func = "Mount",
		},
		mountground = {
			type = "execute",
			name = "Mount random ground mount",
			desc = L["Mount random ground mount no matter if you can fly or not"],
			func = "MountGround",
		},
		list = {
			type = "group",
			name = "List items",
			desc = L["List some things"],
			args = {
				mounts = {
					type = "execute",
					name = "List mounts and spell IDs",
					desc = L["List your mounts and summoning spell IDs"],
					func = "ListMounts",
				},
				newmounts = {
					type = "execute",
					name = "List mounts unknown to this addon",
					desc = L["List mounts unknown to this addon"],
					func = "ListUnknownMounts",
				},
				mountcount = {
					type = "execute",
					name = "List mount amounts for each mountgroup",
					desc = L["List mount amounts for each mount group"],
					func = "listMountAmounts",
				},
			},
		},
	}
}	

function MM:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MikaMounter", MM.options, {"mm", "mikamounter"});
	--MM:RegisterChatCommand("/mikamount", "MM:SlashCommand");
end

function MM:MountGround()
	if ( ( IsMounted() == 1 ) and ( IsFlying() == nil ) ) then
		Dismount();
	else
		local mountCount = GetNumCompanions("MOUNT");
		if ( mountCount == 0 ) then
			-- Keine Mounts, keine Aktion
			return;
		end;
		local mountNumber = 0;
		local mountTables = {};
		if ( GetRealZoneText() == L["Ahn'Qiraj"] ) then table.insert(mountTables,qirajRidingMounts); end;
		if ( IsSwimming() == 1 ) then table.insert(mountTables,waterMounts); end;
		table.insert(mountTables,fastRidingMounts);
		table.insert(mountTables,slowRidingMounts);
		table.insert(mountTables,walkRidingMounts);
		local mountTable = {};
		local mountCount = 0;
		local mountNumbers = {};
		for i = 1, table.getn(mountTables) do
			if ( mountCount == 0 ) then
				mountTable = mountTables[i];
				mountNumbers = MM:getMountNumbers(mountTable);
				mountCount = table.getn(mountNumbers);
				mountNumber = math.floor(math.random() * mountCount + 1);
				if ( mountNumber > mountCount ) then
					mountNumber = mountCount;
				end;
			end;
		end;
		CallCompanion("MOUNT",mountNumbers[mountNumber]);
	end
end

function MM:Mount()
	if ( ( ( IsMounted() == 1 ) or ( CanExitVehicle() == 1 ) ) and ( IsFlying() == nil ) ) then
		if ( IsMounted() ) then
			Dismount();
		else
			VehicleExit();
		end
	else
		local mountCount = GetNumCompanions("MOUNT");
		if ( mountCount == 0 ) then
			-- Keine Mounts, keine Aktion
			return;
		end;
		local mountNumber = 0;
		if ( MM:isFlyableArea() == 1 ) then
			local mountTables = {
				fastFlyingMounts,
				slowFlyingMounts,
				fastRidingMounts,
				slowRidingMounts,
				walkRidingMounts,
			};
			local mountTable = {};
			local mountCount = 0;
			local mountNumbers = {};
			for i = 1, table.getn(mountTables) do
				if ( mountCount == 0 ) then
					mountTable = mountTables[i];
					mountNumbers = MM:getMountNumbers(mountTable);
					mountCount = table.getn(mountNumbers);
					mountNumber = math.floor(math.random() * mountCount + 1);
				end;
			end;
			if ( mountCount > 0 ) then
				CallCompanion("MOUNT",mountNumbers[mountNumber]);
			end;
		else
			local mountTables = {};
			if ( GetRealZoneText() == L["Ahn'Qiraj"] ) then table.insert(mountTables,qirajRidingMounts); end;
			if ( IsSwimming() == 1 ) then table.insert(mountTables,waterMounts); end;
			table.insert(mountTables,fastRidingMounts);
			table.insert(mountTables,slowRidingMounts);
			table.insert(mountTables,walkRidingMounts);
			local mountTable = {};
			local mountCount = 0;
			local mountNumbers = {};
			for i = 1, table.getn(mountTables) do
				if ( mountCount == 0 ) then
					mountTable = mountTables[i];
					mountNumbers = MM:getMountNumbers(mountTable);
					mountCount = table.getn(mountNumbers);
					mountNumber = math.floor(math.random() * mountCount + 1);
				end;
			end;
			if ( mountCount > 0 ) then
				CallCompanion("MOUNT",mountNumbers[mountNumber]);
			end;
		end
	end
end

function MM:findValue(myTable, key)
	for i = 1, table.getn(myTable) do
		if ( myTable[i] == key ) then
			return true;
		end;
	end
	return false;
end

function MM:listMountAmounts()
	local compCount = GetNumCompanions("MOUNT");
	local qiraj = 0;
	local slowR = 0;
	local fastR = 0;
	local slowF = 0;
	local fastF = 0;
	local walkR = 0;
	local water = 0;
	for i = 1 , compCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( MM:findValue(qirajRidingMounts,creatureSpellID) ) then
			qiraj = qiraj + 1;
		end;
		if ( MM:findValue(slowRidingMounts,creatureSpellID) ) then
			slowR = slowR + 1;
		end;
		if ( MM:findValue(fastRidingMounts,creatureSpellID) ) then
			fastR = fastR + 1;
		end;
		if ( MM:findValue(slowFlyingMounts,creatureSpellID) ) then
			slowF = slowF + 1;
		end;
		if ( MM:findValue(fastFlyingMounts,creatureSpellID) ) then
			fastF = fastF + 1;
		end;
		if ( MM:findValue(walkRidingMounts,creatureSpellID) ) then
			walkR = walkR + 1;
		end;
		if ( MM:findValue(waterMounts,creatureSpellID) ) then
			water = water + 1;
		end;
	end;
	DEFAULT_CHAT_FRAME:AddMessage(qiraj.." "..L["Qiraj Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(walkR.." "..L["Walk Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(water.." "..L["Water Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(slowR.." "..L["Slow Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastR.." "..L["Fast Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(slowF.." "..L["Slow Flying Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastF.." "..L["Fast Flying Mounts"]);
	return compCount;
end;

function MM:getMountNumbers(myMountTable)
	local compCount = GetNumCompanions("MOUNT");
	local goodNumbers = {};
	for i = 1 , compCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( MM:findValue(myMountTable,creatureSpellID) ) then
			table.insert(goodNumbers,i);
		end;
	end;
	return goodNumbers;
end;

function MM:isFlyableArea()
	if ( IsSwimming() == 1 ) then return 0; end;
	if ( GetCurrentMapContinent() == L["Northrend"] ) then
		local i = 1;
		local allowedToFly = false;
		while true do
			local spellName, _ = GetSpellName(i,"spell");
			if ( not spellName ) then
				break; 
			end;
			if ( spellName == L["Cold Weather Flying"] ) then
				allowedToFly = true;
			end;
			i = i+1;
		end;
		if ( not allowedToFly ) then
			return 0;
		end;
	end;
	local badZones = {
		L["Dalaran"],
		L["Wintergrasp"],
	};
	if ( MM:findValue(badZones,GetRealZoneText()) ) then
		local goodZoneTable = {
			L["Krasus' Landing"],
			L["The Underbelly"],
		};
		if ( ( MM:findValue(goodZoneTable,GetSubZoneText()) ) and ( IsFlyableArea() ) ) then 
			if ( GetSubZoneText() == L["The Underbelly"] ) then
				local posX, posY = GetPlayerMapPosition("player");
				if ( ( posX*100 < 29 ) and ( posY*100 > 54 ) ) then
					return 1;
				else
					return 0;
				end;
			else
				return 1;
			end;
		else
			return 0;
		end;
	else
		return IsFlyableArea();
	end;
end

function MM:ListMounts()
	local mountCount = GetNumCompanions("MOUNT");
	local mountIDs = {};
	local mountNames = {};
	for i = 1, mountCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		table.insert(mountIDs,creatureSpellID);
		table.insert(mountNames,creatureName);
	end
	for i = 1, table.getn(mountIDs) do
		DEFAULT_CHAT_FRAME:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
	end
end

function MM:ListUnknownMounts()
	local mountCount = GetNumCompanions("MOUNT");
	local mountIDs = {};
	local mountNames = {};
	for i = 1, mountCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( not ( MM:findValue(qirajRidingMounts,creatureSpellID)
			or MM:findValue(waterMounts,creatureSpellID)
			or MM:findValue(slowRidingMounts,creatureSpellID)
			or MM:findValue(fastRidingMounts,creatureSpellID)
			or MM:findValue(slowFlyingMounts,creatureSpellID)
			or MM:findValue(fastFlyingMounts,creatureSpellID)
			or MM:findValue(walkRidingMounts,creatureSpellID)
		) ) then
			table.insert(mountIDs,creatureSpellID);
			table.insert(mountNames,creatureName);
		end;
	end
	if ( table.getn(mountIDs) == 0 ) then
		DEFAULT_CHAT_FRAME:AddMessage(L["All your mounts are known to this addon."]);
	end
	for i = 1, table.getn(mountIDs) do
		DEFAULT_CHAT_FRAME:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
	end
end

function MM:OnEnable()

end

function MM:OnDisable()

end
